class Run < ActiveRecord::Base

  # This doesn't even need comments
  validates_presence_of :duration
  validates_presence_of :start_time
  #validates_presence_of :playlist
  validates_presence_of :weight
  validates_presence_of :device
  validates_presence_of :calibration

  has_many :snap_shots
  has_many :extended_datas

  # :rock:
  def distance
    self.snap_shots.last.distance
  end

  def pace
    return self.duration/self.distance unless self.distance == 0
  end
  
  def <=> (other)
    return self.start_time <=> other.start_time
  end
end
