require File.dirname(__FILE__) + '/../test_helper'
require 'runs_controller'

# Re-raise errors caught by the controller.
class RunsController; def rescue_action(e) raise e end; end

class RunsControllerTest < Test::Unit::TestCase
  fixtures :runs

  def setup
    @controller = RunsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = runs(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:runs)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:run)
    assert assigns(:run).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:run)
  end

  def test_create
    num_runs = Run.count

    post :create, :run => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_runs + 1, Run.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:run)
    assert assigns(:run).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Run.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Run.find(@first_id)
    }
  end
end
